TaskTracker/Components/NavbarViewComponent.cs
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using TaskTracker.Core;
using TaskTracker.Core.Domain;
using TaskTracker.Helpers;
using TaskTracker.Models;
using TaskTracker.Service.Services;

namespace TaskTracker.Components
{
    public class NavbarViewComponent : ViewComponent
    {
        #region Fields
        private readonly IMapper _mapper;
        private readonly IWorkspaceService _workspaceService;
        private readonly IProjectService _projectService;
        private readonly IWorkContext _workContext;
        private readonly IHttpContextAccessor _httpContextAccessor;
        private readonly IPermissionHelper _permissionHelper;
        #endregion

        #region Ctor
        public NavbarViewComponent(
            IMapper mapper,
            IWorkspaceService workspaceService,
            IProjectService projectService,
            IWorkContext workContext,
            IHttpContextAccessor httpContextAccessor,
            IPermissionHelper permissionHelper)
        {
            _mapper = mapper;
            _workspaceService = workspaceService;
            _projectService = projectService;
            _workContext = workContext;
            _httpContextAccessor = httpContextAccessor;
            _permissionHelper = permissionHelper;
        }
        #endregion

        #region Public Methods
        public async Task<IViewComponentResult> InvokeAsync()
        {

            var user = await _workContext.GetCurrentUserAsync();
            if (user == null)
            {
                _httpContextAccessor.HttpContext.Response.Redirect("/Account/login");
                return View(new BaseViewModel());
            }
            var workspaceId = await _workContext.GetCurrentWorkspaceIdAsync();
            var workspace = await _workspaceService.GetWorkspaceDetailsAsync(workspaceId);

            var projects = await _projectService.GetProjectListByWorkspace(workspaceId);
            var model = new BaseViewModel
            {
                User = _mapper.Map<AppUserModel>(user),
                Workspace = _mapper.Map<WorkspaceModel>(workspace),
                Projects = _mapper.Map<List<ProjectModel>>(projects),
                Permissions = SetUserAccessRights(workspace)
            };

            return View(model);
        }


        #endregion

        #region Private Methods
        private RolePermissionModel SetUserAccessRights(Workspace workspace)
        {
            var permission = _permissionHelper.SetUserAccessRightsByWorkspace(workspace);
            var model = _mapper.Map<RolePermissionModel>(permission);
            return model;
        }
        #endregion
    }
}

TaskTracker/Controllers/WorkspaceController.cs
using AutoMapper;
using Microsoft.AspNetCore.Mvc;
using TaskTracker.Core;
using TaskTracker.Core.Domain;
using TaskTracker.Helpers;
using TaskTracker.Models;
using TaskTracker.Service.Services;

namespace TaskTracker.Controllers
{
    public class WorkspaceController : Controller
    {
        #region Fields
        private readonly IWorkspaceService _workspaceService;
        private readonly IWorkContext _workContext;
        private readonly IPermissionHelper _permissionHelper;
        private readonly IMapper _mapper;
        private readonly ILogger<WorkspaceController> _logger;
        #endregion

        #region Ctor
        public WorkspaceController(
            IWorkspaceService workspaceService,
            IWorkContext workContext,
            IMapper mapper,
            ILogger<WorkspaceController> logger,
            IPermissionHelper permissionHelper)
        {
            _workspaceService = workspaceService;
            _workContext = workContext;
            _mapper = mapper;
            _logger = logger;
            _permissionHelper = permissionHelper;
        }
        #endregion

        #region Public Methods
        [HttpGet]
        public async Task<IActionResult> Index(int id)
        {
            if (await _permissionHelper.CheckWorkspaceAccess(id) == false)
            {
                return NotFound();
            }

            HttpContext?.Session.SetInt32("WorkspaceId", id);
            var workspace = await _workspaceService.GetWorkspaceDetailsAsync(id);
            await InitAccessRights(workspace.Id);

            var model = new WorkspaceViewModel()
            {
                Workspace = _mapper.Map<WorkspaceModel>(workspace)
            };

            return View(model);
        }

        [HttpPost]
        public async Task<IActionResult> Create(string name, string description)
        {
            try
            {
                var ret = await _workspaceService.CreateWorkspaceAsync(_workContext.UserId, name, description);
                _permissionHelper.ResetWorkspaceAccess();
                HttpContext?.Session.SetInt32("WorkspaceId", ret.Id);
                return Json(new StatusResult<int> { IsSuccess = true, Data = ret.Id });
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, ex.Message);
                return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.Generic });
            }

        }

        [HttpPost]
        public async Task<IActionResult> InviteUser(int workspaceId, string email)
        {
            try
            {
                if (await _permissionHelper.CheckWorkspaceAccess(workspaceId) == false)
                {
                    return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.UnAuthorized });
                }

                var ret = await _workspaceService.InviteUserAsync(workspaceId, email);
                return Json(ret);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, ex.Message);
                return Json(new { IsSuccess = false, ErrorMessage = ErrorMessages.Generic });
            }

        }

        [HttpPost]
        public async Task<IActionResult> RemoveUser(int workspaceId, string userId)
        {
            try
            {
                if (await _permissionHelper.CheckWorkspaceAccess(workspaceId) == false)
                {
                    return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.UnAuthorized });
                }
                var ret = await _workspaceService.RemoveUserAsync(workspaceId, userId);
                return Json(ret);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, ex.Message);
                return Json(new { IsSuccess = false, ErrorMessage = ErrorMessages.Generic });
            }
        }

        [HttpGet]
        public async Task<IActionResult> GetRolePermission(int id)
        {
            var ret = await _workspaceService.GetRolePermissionAsync(id);
            return PartialView("_RolePermissionTable", _mapper.Map<RolePermissionModel>(ret));
        }

        [HttpPost]
        public async Task<IActionResult> UpdateUserRole(int workspaceId, string userId, string roleId)
        {
            try
            {
                if (await _permissionHelper.CheckWorkspaceAccess(workspaceId) == false)
                {
                    return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.UnAuthorized });
                }
                var ret = await _workspaceService.UpdateUserRoleAsync(workspaceId, userId, roleId);
                return Json(ret);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, ex.Message);
                return Json(new { IsSuccess = false, ErrorMessage = ErrorMessages.Generic });
            }
        }

        [HttpPost]
        public async Task<IActionResult> UpdateInfo(int id, string name = "", string description = "")
        {
            try
            {
                if (await _permissionHelper.CheckWorkspaceAccess(id) == false)
                {
                    return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.UnAuthorized });
                }
                var ret = await _workspaceService.UpdateWorkspaceDetailsAsync(id, name, description);
                return Json(ret);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, ex.Message);
                return Json(new { IsSuccess = false, ErrorMessage = ErrorMessages.Generic });
            }
        }

        [HttpGet]
        public async Task<IActionResult> GetAssignedWorkspaces()
        {
            var workspaces = await _workspaceService.GetWorkspaceListAsync(_workContext.UserId);
            return PartialView("_SelectWorkspaces", _mapper.Map<List<WorkspaceModel>>(workspaces));
        }

        [HttpGet]
        public IActionResult SwitchWorkspace(int id)
        {
            _permissionHelper.ResetWorkspaceAccess();
            HttpContext?.Session.SetInt32("WorkspaceId", id);
            return Redirect("/");
        }
        [HttpPost]
        public async Task<IActionResult> Delete(int id)
        {
            try
            {
                if (await _permissionHelper.CheckWorkspaceAccess(id) == false)
                {
                    return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.UnAuthorized });
                }
                var ret = await _workspaceService.DeleteWorkspaceAsync(_workContext.UserId, id);
                return Json(ret);
            }
            catch (Exception ex)
            {
                _logger.LogError(ex, ex.Message);
                return Json(new StatusResult { IsSuccess = false, ErrorMessage = ErrorMessages.Generic });
            }
        }
        #endregion

        #region Private Methods
        private async Task InitAccessRights(int workspaceId)
        {
            var accessRights = await _permissionHelper.GetCurrentUserAccessRightsByWorkspace(workspaceId);
            ViewBag.RemoveUser = accessRights.RemoveWorkspaceUser;
            ViewBag.AddUser = accessRights.AddWorkspaceUser;
        }
        #endregion
    }
}

TaskTracker/Views/Shared/Components/Navbar/Default.cshtml
@model BaseViewModel

<header class="topbar">
    <div class="with-vertical">
        <nav class="navbar navbar-expand-lg p-0">
            <a class="navbar-toggler nav-icon-hover p-0 border-0" href="javascript:void(0)" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="p-2">
                    <i class="fa fa-bars fs-7"></i>
                </span>
            </a>
            <div class="shadow collapse navbar-collapse d-flex justify-content-between align-items-center" id="navbarNav" style="margin-left: 270px">
                <div class="w-25 d-flex align-items-center">
                 
                </div>
                <ul class="navbar-nav flex-row ms-auto align-items-center justify-content-center">
                    <li class="nav-item dropdown workspace-selector bg-secondary-subtle rounded border">
                        <div class="hstack gap-3 px-2 py-1 my-1" data-bs-toggle="dropdown">
                            <div class="john-img">
                                @await Html.PartialAsync("_UserAvatar", Model.User, new ViewDataDictionary(ViewData){{"_size", "36"}})
                            </div>
                            @if (Model.Workspace != null)
                            {
                                <div class="john-title">
                                    <span class="text-muted fs-1">Current Workspace</span>
                                    <h6 class="mb-0 fs-3 fw-semibold current-workspace" data-id="@Model.Workspace.Id">@Model.Workspace.Name</h6>
                                </div>
                            }
                        </div>
                        <div class="dropdown-menu content-dd dropdown-menu-end dropdown-menu-animate-up" aria-labelledby="drop1" data-bs-popper="static" style="min-width: 17.5rem">
                            <div class="profile-dropdown position-relative">
                                <a asp-controller="user" asp-action="profile">
                                    <div class="d-flex align-items-center py-3 px-4 border-bottom hover-bg-change">
                                        @await Html.PartialAsync("_UserAvatar", Model.User, new ViewDataDictionary(ViewData){{"_size", "50"}})

                                        <div class="ms-3">
                                            <h5 class="mb-1 fs-2">@Model.User.Name</h5>
                                            <p class="mb-0 d-flex align-items-center gap-2 fs-3">
                                                <i class="fa fa-envelope"></i> @Model.User.Email
                                            </p>
                                        </div>
                                    </div>
                                </a>

                                <div class="message-body">

                                    <a onclick="createWorkspace()" class="py-8 px-7 d-flex align-items-center hover-bg-change">
                                        <span class="d-flex align-items-center justify-content-center text-bg-light rounded-1 p-6">
                                            <i class="fa fa-plus text-success fs-5"></i>
                                        </span>
                                        <div class="w-75 d-inline-block v-middle ps-3">
                                            <h6 class="mb-1 fs-3 fw-semibold lh-base">Create Workspaces</h6>
                                            <span class="fs-2 d-block text-body-secondary">Create new Workspaces </span>
                                        </div>
                                    </a>
                                    <a onclick="selectWorkspace()" class="py-8 px-7 d-flex align-items-center hover-bg-change">
                                        <span class="d-flex align-items-center justify-content-center text-bg-light rounded-1 p-6">
                                            <i class="fa fa-repeat text-primary fs-5"></i>
                                        </span>
                                        <div class="w-75 d-inline-block v-middle ps-3">
                                            <h6 class="mb-1 fs-3 fw-semibold lh-base">Switch Workspace</h6>
                                            <span class="fs-2 d-block text-body-secondary">Switch to different space </span>
                                        </div>
                                    </a>
                                </div>
                                <div class="d-grid py-4 px-7 pt-8">
                                    <a asp-controller="account" asp-action="logout" class="btn bg-danger-subtle text-danger">Log Out</a>
                                </div>
                            </div>
                        </div>
                    </li>
                </ul>
            </div>
        </nav>
    </div>

</header>

<aside class="left-sidebar with-horizontal">
    <div>
        <nav class="sidebar-nav scroll-sidebar container-fluid">
            <ul id="sidebarnav" class="in">

                <li class="nav-small-cap">
                    <i class="ti ti-dots nav-small-cap-icon fs-4"></i>
                    <span class="hide-menu">My Space</span>
                </li>

                <li class="sidebar-item">
                    <a class="sidebar-link has-arrow @(ViewBag.ActiveTab == "Dashboard" ? "active": "")" asp-controller="home" asp-action="index" aria-expanded="false">
                        <span>
                            <i class="fa fa-home ms-2"></i>
                        </span>
                        <span class="hide-menu">Dashboard</span>
                    </a>
                </li>
                <li class="sidebar-item">
                    <a class="sidebar-link has-arrow @(ViewBag.ActiveTab == "Inbox" ? "active" : "")" asp-controller="home" asp-action="inbox" aria-expanded="false">
                        <span>
                            <i class="fa fa-bell ms-2"></i>
                        </span>
                        <span class="hide-menu">Inbox</span>
                    </a>
                </li>

                <li class="nav-small-cap pe-0">
                    <i class="ti ti-dots nav-small-cap-icon fs-4"></i>
                    <div class="d-flex align-items-center justify-content-between">
                        <span class="hide-menu">Projects</span>
                        @if (Model.Permissions.CreateProject)
                        {
                            <button class="btn btn-light btn-sm py-0 px-1" onclick="openCreateProjectModal()"> <i class="fa fa-plus text-muted"></i></button>
                        }
                    </div>
                </li>


                @if (Model.Projects.Any())
                {
                    @foreach (var project in Model.Projects)
                    {

                        <li class="sidebar-item">
                            <a class="sidebar-link has-arrow @(ViewBag.ActiveTab == "Project" && ViewBag.ActiveProject == project.Id? "active": "")" asp-controller="project" asp-action="" asp-route-id="@project.Id" aria-expanded="false">
                                <span>
                                    <i class="fa fa-bell ms-2"></i>
                                </span>
                                <p class="hide-menu mb-0 text-ellipsis project-name">@project.Name</p>
                            </a>
                        </li>
                    }
                }
                else
                {
                    <li>
                        <div class="fixed-profile p-3 mx-2 mb-2 bg-secondary-subtle rounded mt-3">
                            <div class="hstack gap-3">
                                <div class="text-center">
                                    <p>Organize and plan your work with projects</p>
                                </div>
                            </div>
                        </div>
                    </li>
                }

                 <li class="nav-small-cap">
                    <i class="ti ti-dots nav-small-cap-icon fs-4"></i>
                    <span class="hide-menu">Workspace</span>
                </li>
                         <li class="sidebar-item">
                    <a class="sidebar-link has-arrow @(ViewBag.ActiveTab == "Settings" ? "active" : "")" href="@Url.Action("Index", "Workspace", new {id = Model.Workspace.Id})">
                        <span>
                            <i class="fa fa-gear ms-2"></i>
                        </span>
                        <span class="hide-menu">Workspace Settings</span>
                    </a>
                </li>
            </ul>
        </nav>
       
    </div>
</aside>